diff -rupN keepalived-1.2.7/keepalived/include/vrrp_vmac.h keepalived-1.2.7-unicast/keepalived/include/vrrp_vmac.h
--- keepalived-1.2.7/keepalived/include/vrrp_vmac.h	2012-08-13 20:50:25.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/include/vrrp_vmac.h	2013-05-24 10:12:36.592166300 +0200
@@ -36,7 +36,7 @@
 #include "vrrp_if.h"
 
 /* prototypes */
-extern int netlink_link_add_vmac(vrrp_rt *);
-extern int netlink_link_del_vmac(vrrp_rt *);
+extern int netlink_link_add_vmac(vrrp_t *);
+extern int netlink_link_del_vmac(vrrp_t *);
 
 #endif
diff -rupN keepalived-1.2.7/keepalived/vrrp/vrrp.c keepalived-1.2.7-unicast/keepalived/vrrp/vrrp.c
--- keepalived-1.2.7/keepalived/vrrp/vrrp.c	2012-08-17 01:21:28.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/vrrp/vrrp.c	2013-05-24 10:12:36.603166900 +0200
@@ -48,7 +48,7 @@
 
 /* add/remove Virtual IP addresses */
 static int
-vrrp_handle_ipaddress(vrrp_rt * vrrp, int cmd, int type)
+vrrp_handle_ipaddress(vrrp_t * vrrp, int cmd, int type)
 {
 	if (debug & 32)
 		log_message(LOG_INFO, "VRRP_Instance(%s) %s protocol %s", vrrp->iname,
@@ -60,7 +60,7 @@ vrrp_handle_ipaddress(vrrp_rt * vrrp, in
 
 /* add/remove Virtual routes */
 static int
-vrrp_handle_iproutes(vrrp_rt * vrrp, int cmd)
+vrrp_handle_iproutes(vrrp_t * vrrp, int cmd)
 {
 	if (debug & 32)
 		log_message(LOG_INFO, "VRRP_Instance(%s) %s protocol Virtual Routes",
@@ -72,34 +72,34 @@ vrrp_handle_iproutes(vrrp_rt * vrrp, int
 
 /* IP header length */
 static int
-vrrp_iphdr_len(vrrp_rt * vrrp)
+vrrp_iphdr_len(vrrp_t * vrrp)
 {
-	return sizeof (struct iphdr);
+	return sizeof(struct iphdr);
 }
 
 /* IPSEC AH header length */
 int
 vrrp_ipsecah_len(void)
 {
-	return sizeof (ipsec_ah);
+	return sizeof(ipsec_ah_t);
 }
 
 /* VRRP header length */
 static int
-vrrp_hd_len(vrrp_rt * vrrp)
+vrrp_hd_len(vrrp_t * vrrp)
 {
-	int len = sizeof (vrrp_pkt);
+	int len = sizeof(vrrphdr_t);
 	if (vrrp->family == AF_INET)
 		len += VRRP_AUTH_LEN + ((!LIST_ISEMPTY(vrrp->vip)) ? LIST_SIZE(vrrp->vip) * sizeof (uint32_t) : 0);
         return len;
 }
 
 /* VRRP header pointer from buffer */
-vrrp_pkt *
+vrrphdr_t *
 vrrp_get_header(sa_family_t family, char *buf, int *proto, uint32_t *saddr)
 {
 	struct iphdr *iph;
-	vrrp_pkt *hd = NULL;
+	vrrphdr_t *hd = NULL;
 
 	if (family == AF_INET) {
 		iph = (struct iphdr *) buf;
@@ -109,18 +109,18 @@ vrrp_get_header(sa_family_t family, char
 		switch (iph->protocol) {
 		case IPPROTO_IPSEC_AH:
 			*proto = IPPROTO_IPSEC_AH;
-			hd = (vrrp_pkt *) ((char *) iph + (iph->ihl << 2) +
+			hd = (vrrphdr_t *) ((char *) iph + (iph->ihl << 2) +
 					   vrrp_ipsecah_len());
 			break;
 		case IPPROTO_VRRP:
 			*proto = IPPROTO_VRRP;
-			hd = (vrrp_pkt *) ((char *) iph + (iph->ihl << 2));
+			hd = (vrrphdr_t *) ((char *) iph + (iph->ihl << 2));
 			break;
 		}
 	} else if (family == AF_INET6) {
 		*proto = IPPROTO_VRRP;
 		*saddr = 0;
-		hd = (vrrp_pkt *) buf;
+		hd = (vrrphdr_t *) buf;
 	}
 
 	return hd;
@@ -131,10 +131,10 @@ vrrp_get_header(sa_family_t family, char
  * return 0 for a valid pkt, != 0 otherwise.
  */
 static int
-vrrp_in_chk_ipsecah(vrrp_rt * vrrp, char *buffer)
+vrrp_in_chk_ipsecah(vrrp_t * vrrp, char *buffer)
 {
 	struct iphdr *ip = (struct iphdr *) (buffer);
-	ipsec_ah *ah = (ipsec_ah *) ((char *) ip + (ip->ihl << 2));
+	ipsec_ah_t *ah = (ipsec_ah_t *) ((char *) ip + (ip->ihl << 2));
 	unsigned char *digest;
 	uint32_t backup_auth_data[3];
 
@@ -194,7 +194,7 @@ vrrp_in_chk_ipsecah(vrrp_rt * vrrp, char
 
 /* check if ipaddr is present in VIP buffer */
 static int
-vrrp_in_chk_vips(vrrp_rt * vrrp, ip_address *ipaddress, unsigned char *buffer)
+vrrp_in_chk_vips(vrrp_t * vrrp, ip_address_t *ipaddress, unsigned char *buffer)
 {
 	int i;
 	uint32_t ipbuf;
@@ -220,14 +220,14 @@ vrrp_in_chk_vips(vrrp_rt * vrrp, ip_addr
  * return 0 if the pkt is valid, != 0 otherwise.
  */
 static int
-vrrp_in_chk(vrrp_rt * vrrp, char *buffer)
+vrrp_in_chk(vrrp_t * vrrp, char *buffer)
 {
 	struct iphdr *ip;
-	int ihl, vrrp_pkt_len;
-	ipsec_ah *ah;
-	vrrp_pkt *hd;
+	int ihl, vrrphdr_len;
+	ipsec_ah_t *ah;
+	vrrphdr_t *hd;
 	unsigned char *vips;
-	ip_address *ipaddress;
+	ip_address_t *ipaddress;
 	element e;
 
 	/* IPv4 related */
@@ -237,14 +237,14 @@ vrrp_in_chk(vrrp_rt * vrrp, char *buffer
 		ihl = ip->ihl << 2;
 
 		if (vrrp->auth_type == VRRP_AUTH_AH) {
-			ah = (ipsec_ah *) (buffer + ihl);
-			hd = (vrrp_pkt *) (ah + vrrp_ipsecah_len());
+			ah = (ipsec_ah_t *) (buffer + ihl);
+			hd = (vrrphdr_t *) (ah + vrrp_ipsecah_len());
 		} else {
-			hd = (vrrp_pkt *) (buffer + ihl);
+			hd = (vrrphdr_t *) (buffer + ihl);
 		}
 	
 		/* pointer to vrrp vips pkt zone */
-		vips = (unsigned char *) ((char *) hd + sizeof (vrrp_pkt));
+		vips = (unsigned char *) ((char *) hd + sizeof(vrrphdr_t));
 	
 		/* MUST verify that the IP TTL is 255 */
 		if (ip->ttl != VRRP_IP_TTL) {
@@ -257,10 +257,10 @@ vrrp_in_chk(vrrp_rt * vrrp, char *buffer
 		 * MUST verify that the received packet length is greater than or
 		 * equal to the VRRP header
 		 */
-		if ((ntohs(ip->tot_len) - ihl) <= sizeof (vrrp_pkt)) {
+		if ((ntohs(ip->tot_len) - ihl) <= sizeof(vrrphdr_t)) {
 			log_message(LOG_INFO,
 			       "ip payload too short. %d and expect at least %d",
-			       ntohs(ip->tot_len) - ihl, sizeof (vrrp_pkt));
+			       ntohs(ip->tot_len) - ihl, sizeof(vrrphdr_t));
 			return VRRP_PACKET_KO;
 		}
 
@@ -304,12 +304,12 @@ vrrp_in_chk(vrrp_rt * vrrp, char *buffer
 			return (vrrp_in_chk_ipsecah(vrrp, buffer));
 
 		/* Set expected vrrp packet lenght */
-		vrrp_pkt_len = sizeof(vrrp_pkt) + VRRP_AUTH_LEN + hd->naddr * sizeof(uint32_t);
+		vrrphdr_len = sizeof(vrrphdr_t) + VRRP_AUTH_LEN + hd->naddr * sizeof(uint32_t);
 
 	} else if (vrrp->family == AF_INET6) { /* IPv6 related */
 
-		hd = (vrrp_pkt *) buffer;
-		vrrp_pkt_len = sizeof(vrrp_pkt);
+		hd = (vrrphdr_t *) buffer;
+		vrrphdr_len = sizeof(vrrphdr_t);
 
 	} else {
 		return VRRP_PACKET_KO;
@@ -323,7 +323,7 @@ vrrp_in_chk(vrrp_rt * vrrp, char *buffer
 	}
 
 	/* MUST verify the VRRP checksum */
-	if (in_csum((u_short *) hd, vrrp_pkt_len, 0)) {
+	if (in_csum((u_short *) hd, vrrphdr_len, 0)) {
 		log_message(LOG_INFO, "Invalid vrrp checksum");
 		return VRRP_PACKET_KO;
 	}
@@ -338,7 +338,7 @@ vrrp_in_chk(vrrp_rt * vrrp, char *buffer
 		return VRRP_PACKET_KO;
 	}
 
-	/* MUST verify that the VRID is valid on the receiving interface */
+	/* MUST verify that the VRID is valid on the receiving interface_t */
 	if (vrrp->vrid != hd->vrid) {
 		log_message(LOG_INFO,
 		       "received VRID mismatch. Received %d, Expected %d",
@@ -367,7 +367,7 @@ vrrp_in_chk(vrrp_rt * vrrp, char *buffer
 
 /* build IP header */
 static void
-vrrp_build_ip(vrrp_rt * vrrp, char *buffer, int buflen)
+vrrp_build_ip(vrrp_t * vrrp, char *buffer, int buflen)
 {
 	struct iphdr *ip = (struct iphdr *) (buffer);
 
@@ -396,12 +396,12 @@ vrrp_build_ip(vrrp_rt * vrrp, char *buff
 
 /* build IPSEC AH header */
 static void
-vrrp_build_ipsecah(vrrp_rt * vrrp, char *buffer, int buflen)
+vrrp_build_ipsecah(vrrp_t * vrrp, char *buffer, int buflen)
 {
 	ICV_mutable_fields *ip_mutable_fields;
 	unsigned char *digest;
 	struct iphdr *ip = (struct iphdr *) (buffer);
-	ipsec_ah *ah = (ipsec_ah *) (buffer + sizeof (struct iphdr));
+	ipsec_ah_t *ah = (ipsec_ah_t *) (buffer + sizeof (struct iphdr));
 
 	/* alloc a temp memory space to stock the ip mutable fields */
 	ip_mutable_fields = (ICV_mutable_fields *) MALLOC(sizeof (ICV_mutable_fields));
@@ -480,13 +480,13 @@ vrrp_build_ipsecah(vrrp_rt * vrrp, char
 
 /* build VRRP header */
 static int
-vrrp_build_vrrp(vrrp_rt * vrrp, int prio, char *buffer)
+vrrp_build_vrrp(vrrp_t * vrrp, int prio, char *buffer)
 {
 	int i = 0;
-	vrrp_pkt *hd = (vrrp_pkt *) buffer;
+	vrrphdr_t *hd = (vrrphdr_t *) buffer;
 	uint32_t *iparr;
 	element e;
-	ip_address *ip_addr;
+	ip_address_t *ip_addr;
 
 	/* Family independant */
 	hd->vers_type = (VRRP_VERSION << 4) | VRRP_PKT_ADVERT;
@@ -526,7 +526,7 @@ vrrp_build_vrrp(vrrp_rt * vrrp, int prio
 
 /* build VRRP packet */
 static void
-vrrp_build_pkt(vrrp_rt * vrrp, int prio)
+vrrp_build_pkt(vrrp_t * vrrp, int prio)
 {
 	char *bufptr;
 	int len;
@@ -566,7 +566,7 @@ vrrp_build_pkt(vrrp_rt * vrrp, int prio)
 
 /* send VRRP packet */
 static int
-vrrp_send_pkt(vrrp_rt * vrrp)
+vrrp_send_pkt(vrrp_t * vrrp)
 {
 	struct sockaddr_in6 dst6;
 	struct sockaddr_in dst4;
@@ -605,7 +605,7 @@ vrrp_send_pkt(vrrp_rt * vrrp)
 
 /* Allocate the sending buffer */
 static void
-vrrp_alloc_send_buffer(vrrp_rt * vrrp)
+vrrp_alloc_send_buffer(vrrp_t * vrrp)
 {
 	vrrp->send_buffer_size = vrrp_hd_len(vrrp);
 
@@ -620,7 +620,7 @@ vrrp_alloc_send_buffer(vrrp_rt * vrrp)
 
 /* send VRRP advertissement */
 int
-vrrp_send_adv(vrrp_rt * vrrp, int prio)
+vrrp_send_adv(vrrp_t * vrrp, int prio)
 {
 	/* alloc send buffer */
 	if (!vrrp->send_buffer)
@@ -637,7 +637,7 @@ vrrp_send_adv(vrrp_rt * vrrp, int prio)
 
 /* Received packet processing */
 int
-vrrp_check_packet(vrrp_rt * vrrp, char *buf, int buflen)
+vrrp_check_packet(vrrp_t * vrrp, char *buf, int buflen)
 {
 	int ret;
 
@@ -660,7 +660,7 @@ vrrp_check_packet(vrrp_rt * vrrp, char *
 
 /* Gratuitous ARP on each VIP */
 static void
-vrrp_send_update(vrrp_rt * vrrp, ip_address * ipaddress, int idx)
+vrrp_send_update(vrrp_t * vrrp, ip_address_t * ipaddress, int idx)
 {
 	char *msg;
 	char addr_str[41];
@@ -682,10 +682,10 @@ vrrp_send_update(vrrp_rt * vrrp, ip_addr
 }
 
 void
-vrrp_send_link_update(vrrp_rt * vrrp)
+vrrp_send_link_update(vrrp_t * vrrp)
 {
 	int j;
-	ip_address *ipaddress;
+	ip_address_t *ipaddress;
 	element e;
 
 	/* Only send gratuitous ARP if VIP are set */
@@ -712,7 +712,7 @@ vrrp_send_link_update(vrrp_rt * vrrp)
 
 /* becoming master */
 void
-vrrp_state_become_master(vrrp_rt * vrrp)
+vrrp_state_become_master(vrrp_t * vrrp)
 {
 	/* add the ip addresses */
 	if (!LIST_ISEMPTY(vrrp->vip))
@@ -743,7 +743,7 @@ vrrp_state_become_master(vrrp_rt * vrrp)
 }
 
 void
-vrrp_state_goto_master(vrrp_rt * vrrp)
+vrrp_state_goto_master(vrrp_t * vrrp)
 {
 	/*
 	 * Send an advertisement. To force a new master
@@ -760,7 +760,7 @@ vrrp_state_goto_master(vrrp_rt * vrrp)
 
 /* leaving master state */
 void
-vrrp_restore_interface(vrrp_rt * vrrp, int advF)
+vrrp_restore_interface(vrrp_t * vrrp, int advF)
 {
         /* if we stop vrrp, warn the other routers to speed up the recovery */
 	if (advF) {
@@ -792,7 +792,7 @@ vrrp_restore_interface(vrrp_rt * vrrp, i
 }
 
 void
-vrrp_state_leave_master(vrrp_rt * vrrp)
+vrrp_state_leave_master(vrrp_t * vrrp)
 {
 	if (VRRP_VIP_ISSET(vrrp)) {
 #ifdef _HAVE_IPVS_SYNCD_
@@ -830,9 +830,9 @@ vrrp_state_leave_master(vrrp_rt * vrrp)
 
 /* BACKUP state processing */
 void
-vrrp_state_backup(vrrp_rt * vrrp, char *buf, int buflen)
+vrrp_state_backup(vrrp_t * vrrp, char *buf, int buflen)
 {
-	vrrp_pkt *hd;
+	vrrphdr_t *hd;
 	uint32_t saddr;
 	int ret = 0, proto;
 
@@ -859,7 +859,7 @@ vrrp_state_backup(vrrp_rt * vrrp, char *
 
 /* MASTER state processing */
 int
-vrrp_state_master_tx(vrrp_rt * vrrp, const int prio)
+vrrp_state_master_tx(vrrp_t * vrrp, const int prio)
 {
 	int ret = 0;
 
@@ -877,12 +877,12 @@ vrrp_state_master_tx(vrrp_rt * vrrp, con
 }
 
 int
-vrrp_state_master_rx(vrrp_rt * vrrp, char *buf, int buflen)
+vrrp_state_master_rx(vrrp_t * vrrp, char *buf, int buflen)
 {
-	vrrp_pkt *hd = NULL;
+	vrrphdr_t *hd = NULL;
 	int ret = 0, proto = 0;
 	uint32_t saddr = 0;
-	ipsec_ah *ah;
+	ipsec_ah_t *ah;
 
 	/* return on link failure */
 	if (vrrp->wantstate == VRRP_STATE_GOTO_FAULT) {
@@ -907,7 +907,7 @@ vrrp_state_master_rx(vrrp_rt * vrrp, cha
 		log_message(LOG_INFO, "VRRP_Instance(%s) Received lower prio advert"
 				      ", forcing new election", vrrp->iname);
 		if (proto == IPPROTO_IPSEC_AH) {
-			ah = (ipsec_ah *) (buf + sizeof(struct iphdr));
+			ah = (ipsec_ah_t *) (buf + sizeof(struct iphdr));
 			log_message(LOG_INFO, "VRRP_Instance(%s) IPSEC-AH : Syncing seq_num"
 					      " - Increment seq"
 					    , vrrp->iname);
@@ -927,7 +927,7 @@ vrrp_state_master_rx(vrrp_rt * vrrp, cha
 			log_message(LOG_INFO, "VRRP_Instance(%s) Received higher prio advert"
 					    , vrrp->iname);
 			if (proto == IPPROTO_IPSEC_AH) {
-				ah = (ipsec_ah *) (buf + sizeof(struct iphdr));
+				ah = (ipsec_ah_t *) (buf + sizeof(struct iphdr));
 				log_message(LOG_INFO, "VRRP_Instance(%s) IPSEC-AH : Syncing seq_num"
 						      " - Decrement seq"
 						    , vrrp->iname);
@@ -955,9 +955,9 @@ vrrp_state_master_rx(vrrp_rt * vrrp, cha
 }
 
 int
-vrrp_state_fault_rx(vrrp_rt * vrrp, char *buf, int buflen)
+vrrp_state_fault_rx(vrrp_t * vrrp, char *buf, int buflen)
 {
-	vrrp_pkt *hd;
+	vrrphdr_t *hd;
 	uint32_t saddr;
 	int ret = 0, proto;
 
@@ -980,7 +980,7 @@ vrrp_state_fault_rx(vrrp_rt * vrrp, char
 
 /* check for minimum configuration requirements */
 static int
-chk_min_cfg(vrrp_rt * vrrp)
+chk_min_cfg(vrrp_t * vrrp)
 {
 	if (vrrp->vrid == 0) {
 		log_message(LOG_INFO, "VRRP_Instance(%s) the virtual id must be set!",
@@ -1000,10 +1000,10 @@ chk_min_cfg(vrrp_rt * vrrp)
 int
 open_vrrp_send_socket(sa_family_t family, int proto, int idx)
 {
-	interface *ifp;
+	interface_t *ifp;
 	int fd = -1;
 
-	/* Retreive interface */
+	/* Retreive interface_t */
 	ifp = if_get_by_ifindex(idx);
 
 	/* Create and init socket descriptor */
@@ -1043,10 +1043,10 @@ open_vrrp_send_socket(sa_family_t family
 int
 open_vrrp_socket(sa_family_t family, int proto, int idx)
 {
-	interface *ifp;
+	interface_t *ifp;
 	int fd = -1;
 
-	/* Retreive interface */
+	/* Retreive interface_t */
 	ifp = if_get_by_ifindex(idx);
 
 	/* open the socket */
@@ -1071,14 +1071,14 @@ open_vrrp_socket(sa_family_t family, int
 }
 
 void
-close_vrrp_socket(vrrp_rt * vrrp)
+close_vrrp_socket(vrrp_t * vrrp)
 {
 	if_leave_vrrp_group(vrrp->family, vrrp->fd_in, vrrp->ifp);
 	close(vrrp->fd_out);
 }
 
 int
-new_vrrp_socket(vrrp_rt * vrrp)
+new_vrrp_socket(vrrp_t * vrrp)
 {
 	int old_fd = vrrp->fd_in;
 	int proto;
@@ -1103,7 +1103,7 @@ shutdown_vrrp_instances(void)
 {
 	list l = vrrp_data->vrrp;
 	element e;
-	vrrp_rt *vrrp;
+	vrrp_t *vrrp;
 
 	for (e = LIST_HEAD(l); e; ELEMENT_NEXT(e)) {
 		vrrp = ELEMENT_DATA(e);
@@ -1138,7 +1138,7 @@ shutdown_vrrp_instances(void)
 
 /* complete vrrp structure */
 static int
-vrrp_complete_instance(vrrp_rt * vrrp)
+vrrp_complete_instance(vrrp_t * vrrp)
 {
 	vrrp->state = VRRP_STATE_INIT;
 	if (!vrrp->adver_int)
@@ -1154,8 +1154,8 @@ vrrp_complete_init(void)
 {
 	list l;
 	element e;
-	vrrp_rt *vrrp;
-	vrrp_sgroup *sgroup;
+	vrrp_t *vrrp;
+	vrrp_sgroup_t *sgroup;
 
 	/* Complete VRRP instance initialization */
 	l = vrrp_data->vrrp;
@@ -1176,12 +1176,12 @@ vrrp_complete_init(void)
 }
 
 /* Try to find a VRRP instance */
-static vrrp_rt *
-vrrp_exist(vrrp_rt * old_vrrp)
+static vrrp_t *
+vrrp_exist(vrrp_t * old_vrrp)
 {
 	element e;
 	list l = vrrp_data->vrrp;
-	vrrp_rt *vrrp;
+	vrrp_t *vrrp;
 
 	if (LIST_ISEMPTY(l))
 		return NULL;
@@ -1197,9 +1197,9 @@ vrrp_exist(vrrp_rt * old_vrrp)
 
 /* Clear VIP|EVIP not present into the new data */
 static void
-clear_diff_vrrp_vip(vrrp_rt * old_vrrp, int type)
+clear_diff_vrrp_vip(vrrp_t * old_vrrp, int type)
 {
-	vrrp_rt *vrrp = vrrp_exist(old_vrrp);
+	vrrp_t *vrrp = vrrp_exist(old_vrrp);
 	list l = (type == VRRP_VIP_TYPE) ? old_vrrp->vip : old_vrrp->evip;
 	list n = (type == VRRP_VIP_TYPE) ? vrrp->vip : vrrp->evip;
 	clear_diff_address(l, n);
@@ -1207,24 +1207,24 @@ clear_diff_vrrp_vip(vrrp_rt * old_vrrp,
 
 /* Clear virtual routes not present in the new data */
 static void
-clear_diff_vrrp_vroutes(vrrp_rt * old_vrrp)
+clear_diff_vrrp_vroutes(vrrp_t * old_vrrp)
 {
-	vrrp_rt *vrrp = vrrp_exist(old_vrrp);
+	vrrp_t *vrrp = vrrp_exist(old_vrrp);
 	clear_diff_routes(old_vrrp->vroutes, vrrp->vroutes);
 }
 
 /* Keep the state from before reload */
 static void
-reset_vrrp_state(vrrp_rt * old_vrrp)
+reset_vrrp_state(vrrp_t * old_vrrp)
 {
 	/* Keep VRRP state, ipsec AH seq_number */
-	vrrp_rt *vrrp = vrrp_exist(old_vrrp);
+	vrrp_t *vrrp = vrrp_exist(old_vrrp);
 	vrrp->state = old_vrrp->state;
 	vrrp->init_state = old_vrrp->state;
 	vrrp->wantstate = old_vrrp->state;
 	if (!old_vrrp->sync)
 		vrrp->effective_priority = old_vrrp->effective_priority;
-	memcpy(vrrp->ipsecah_counter, old_vrrp->ipsecah_counter, sizeof(seq_counter));
+	memcpy(vrrp->ipsecah_counter, old_vrrp->ipsecah_counter, sizeof(seq_counter_t));
 
 #ifdef _HAVE_IPVS_SYNCD_
 	if (old_vrrp->lvs_syncd_if)
@@ -1257,14 +1257,14 @@ clear_diff_vrrp(void)
 {
 	element e;
 	list l = old_vrrp_data->vrrp;
-	vrrp_rt *vrrp;
+	vrrp_t *vrrp;
 
 	if (LIST_ISEMPTY(l))
 		return;
 
 	for (e = LIST_HEAD(l); e; ELEMENT_NEXT(e)) {
 		vrrp = ELEMENT_DATA(e);
-		vrrp_rt *new_vrrp;
+		vrrp_t *new_vrrp;
 
 		/*
 		 * Try to find this vrrp into the new conf data
@@ -1308,7 +1308,7 @@ clear_diff_script(void)
 {
 	element e;
 	list l = old_vrrp_data->vrrp_script;
-	vrrp_script *vscript, *nvscript;
+	vrrp_script_t *vscript, *nvscript;
 
 	if (LIST_ISEMPTY(l))
 		return;
diff -rupN keepalived-1.2.7/keepalived/vrrp/vrrp_arp.c keepalived-1.2.7-unicast/keepalived/vrrp/vrrp_arp.c
--- keepalived-1.2.7/keepalived/vrrp/vrrp_arp.c	2012-08-13 20:50:25.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/vrrp/vrrp_arp.c	2013-05-24 10:12:36.605167000 +0200
@@ -34,7 +34,7 @@ char *garp_buffer;
 int garp_fd;
 
 /* Send the gratuitous ARP message */
-static int send_arp(ip_address *ipaddress)
+static int send_arp(ip_address_t *ipaddress)
 {
 	struct sockaddr_ll sll;
 	int len;
@@ -47,7 +47,7 @@ static int send_arp(ip_address *ipaddres
 	sll.sll_ifindex = IF_INDEX(ipaddress->ifp);
 
 	/* Send packet */
-	len = sendto(garp_fd, garp_buffer, sizeof(m_arphdr) + ETHER_HDR_LEN
+	len = sendto(garp_fd, garp_buffer, sizeof(arphdr_t) + ETHER_HDR_LEN
 		     , 0, (struct sockaddr *)&sll, sizeof(sll));
 	if (len < 0)
 		log_message(LOG_INFO, "Error sending gratuitous ARP on %s for %s",
@@ -56,10 +56,10 @@ static int send_arp(ip_address *ipaddres
 }
 
 /* Build a gratuitous ARP message over a specific interface */
-int send_gratuitous_arp(ip_address *ipaddress)
+int send_gratuitous_arp(ip_address_t *ipaddress)
 {
 	struct ether_header *eth = (struct ether_header *) garp_buffer;
-	m_arphdr *arph		 = (m_arphdr *) (garp_buffer + ETHER_HDR_LEN);
+	arphdr_t *arph		 = (arphdr_t *) (garp_buffer + ETHER_HDR_LEN);
 	char *hwaddr		 = (char *) IF_HWADDR(ipaddress->ifp);
 	int len;
 
@@ -83,7 +83,7 @@ int send_gratuitous_arp(ip_address *ipad
 	len = send_arp(ipaddress);
 
 	/* Cleanup room for next round */
-	memset(garp_buffer, 0, sizeof(m_arphdr) + ETHER_HDR_LEN);
+	memset(garp_buffer, 0, sizeof(arphdr_t) + ETHER_HDR_LEN);
 	return len;
 }
 
@@ -94,7 +94,7 @@ int send_gratuitous_arp(ip_address *ipad
 void gratuitous_arp_init(void)
 {
 	/* Initalize shared buffer */
-	garp_buffer = (char *)MALLOC(sizeof(m_arphdr) + ETHER_HDR_LEN);
+	garp_buffer = (char *)MALLOC(sizeof(arphdr_t) + ETHER_HDR_LEN);
 
 	/* Create the socket descriptor */
 	garp_fd = socket(PF_PACKET, SOCK_RAW, htons(ETH_P_RARP));
diff -rupN keepalived-1.2.7/keepalived/vrrp/vrrp_data.c keepalived-1.2.7-unicast/keepalived/vrrp/vrrp_data.c
--- keepalived-1.2.7/keepalived/vrrp/vrrp_data.c	2012-08-29 00:05:12.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/vrrp/vrrp_data.c	2013-05-24 10:12:36.608167200 +0200
@@ -30,8 +30,8 @@
 #include "logger.h"
 
 /* global vars */
-vrrp_conf_data *vrrp_data = NULL;
-vrrp_conf_data *old_vrrp_data = NULL;
+vrrp_data_t *vrrp_data = NULL;
+vrrp_data_t *old_vrrp_data = NULL;
 char *vrrp_buffer;
 
 /* Static addresses facility function */
@@ -56,7 +56,7 @@ alloc_sroute(vector_t *strvec)
 static void
 free_vgroup(void *data)
 {
-	vrrp_sgroup *vgroup = data;
+	vrrp_sgroup_t *vgroup = data;
 
 	FREE(vgroup->gname);
 	free_strvec(vgroup->iname);
@@ -70,7 +70,7 @@ free_vgroup(void *data)
 static void
 dump_vgroup(void *data)
 {
-	vrrp_sgroup *vgroup = data;
+	vrrp_sgroup_t *vgroup = data;
 	int i;
 	char *str;
 
@@ -101,7 +101,7 @@ dump_vgroup(void *data)
 static void
 free_vscript(void *data)
 {
-	vrrp_script *vscript = data;
+	vrrp_script_t *vscript = data;
 
 	FREE(vscript->sname);
 	FREE_PTR(vscript->script);
@@ -110,7 +110,7 @@ free_vscript(void *data)
 static void
 dump_vscript(void *data)
 {
-	vrrp_script *vscript = data;
+	vrrp_script_t *vscript = data;
 	char *str;
 
 	log_message(LOG_INFO, " VRRP Script = %s", vscript->sname);
@@ -139,7 +139,7 @@ static void
 free_sock(void *sock_data)
 {
 	sock_t *sock = sock_data;
-	interface *ifp;
+	interface_t *ifp;
 	if (sock->fd_in > 0) {
 		ifp = if_get_by_ifindex(sock->ifindex);
 		if_leave_vrrp_group(sock->family, sock->fd_in, ifp);
@@ -163,7 +163,7 @@ dump_sock(void *sock_data)
 static void
 free_vrrp(void *data)
 {
-	vrrp_rt *vrrp = data;
+	vrrp_t *vrrp = data;
 	element e;
 
 	FREE(vrrp->iname);
@@ -194,7 +194,7 @@ free_vrrp(void *data)
 static void
 dump_vrrp(void *data)
 {
-	vrrp_rt *vrrp = data;
+	vrrp_t *vrrp = data;
 	char auth_data[sizeof(vrrp->auth_data) + 1];
 
 	log_message(LOG_INFO, " VRRP Instance = %s", vrrp->iname);
@@ -278,10 +278,10 @@ void
 alloc_vrrp_sync_group(char *gname)
 {
 	int size = strlen(gname);
-	vrrp_sgroup *new;
+	vrrp_sgroup_t *new;
 
 	/* Allocate new VRRP group structure */
-	new = (vrrp_sgroup *) MALLOC(sizeof (vrrp_sgroup));
+	new = (vrrp_sgroup_t *) MALLOC(sizeof(vrrp_sgroup_t));
 	new->gname = (char *) MALLOC(size + 1);
 	new->state = VRRP_STATE_INIT;
 	memcpy(new->gname, gname, size);
@@ -294,12 +294,12 @@ void
 alloc_vrrp(char *iname)
 {
 	int size = strlen(iname);
-	seq_counter *counter;
-	vrrp_rt *new;
+	seq_counter_t *counter;
+	vrrp_t *new;
 
 	/* Allocate new VRRP structure */
-	new = (vrrp_rt *) MALLOC(sizeof (vrrp_rt));
-	counter = (seq_counter *) MALLOC(sizeof (seq_counter));
+	new = (vrrp_t *) MALLOC(sizeof(vrrp_t));
+	counter = (seq_counter_t *) MALLOC(sizeof(seq_counter_t));
 
 	/* Build the structure */
 	new->ipsecah_counter = counter;
@@ -318,7 +318,7 @@ alloc_vrrp(char *iname)
 void
 alloc_vrrp_track(vector_t *strvec)
 {
-	vrrp_rt *vrrp = LIST_TAIL_DATA(vrrp_data->vrrp);
+	vrrp_t *vrrp = LIST_TAIL_DATA(vrrp_data->vrrp);
 
 	if (LIST_ISEMPTY(vrrp->track_ifp))
 		vrrp->track_ifp = alloc_list(NULL, dump_track);
@@ -328,7 +328,7 @@ alloc_vrrp_track(vector_t *strvec)
 void
 alloc_vrrp_track_script(vector_t *strvec)
 {
-	vrrp_rt *vrrp = LIST_TAIL_DATA(vrrp_data->vrrp);
+	vrrp_t *vrrp = LIST_TAIL_DATA(vrrp_data->vrrp);
 
 	if (LIST_ISEMPTY(vrrp->track_script))
 		vrrp->track_script = alloc_list(NULL, dump_track_script);
@@ -338,7 +338,7 @@ alloc_vrrp_track_script(vector_t *strvec
 void
 alloc_vrrp_vip(vector_t *strvec)
 {
-	vrrp_rt *vrrp = LIST_TAIL_DATA(vrrp_data->vrrp);
+	vrrp_t *vrrp = LIST_TAIL_DATA(vrrp_data->vrrp);
 	if (vrrp->ifp == NULL) {
 		log_message(LOG_ERR, "Configuration error: VRRP definition must belong to an interface");
 	}
@@ -350,7 +350,7 @@ alloc_vrrp_vip(vector_t *strvec)
 void
 alloc_vrrp_evip(vector_t *strvec)
 {
-	vrrp_rt *vrrp = LIST_TAIL_DATA(vrrp_data->vrrp);
+	vrrp_t *vrrp = LIST_TAIL_DATA(vrrp_data->vrrp);
 
 	if (LIST_ISEMPTY(vrrp->evip))
 		vrrp->evip = alloc_list(free_ipaddress, dump_ipaddress);
@@ -360,7 +360,7 @@ alloc_vrrp_evip(vector_t *strvec)
 void
 alloc_vrrp_vroute(vector_t *strvec)
 {
-	vrrp_rt *vrrp = LIST_TAIL_DATA(vrrp_data->vrrp);
+	vrrp_t *vrrp = LIST_TAIL_DATA(vrrp_data->vrrp);
 
 	if (LIST_ISEMPTY(vrrp->vroutes))
 		vrrp->vroutes = alloc_list(free_iproute, dump_iproute);
@@ -371,10 +371,10 @@ void
 alloc_vrrp_script(char *sname)
 {
 	int size = strlen(sname);
-	vrrp_script *new;
+	vrrp_script_t *new;
 
 	/* Allocate new VRRP group structure */
-	new = (vrrp_script *) MALLOC(sizeof (vrrp_script));
+	new = (vrrp_script_t *) MALLOC(sizeof(vrrp_script_t));
 	new->sname = (char *) MALLOC(size + 1);
 	memcpy(new->sname, sname, size + 1);
 	new->interval = VRRP_SCRIPT_DI * TIMER_HZ;
@@ -400,12 +400,12 @@ free_vrrp_buffer(void)
 	FREE(vrrp_buffer);
 }
 
-vrrp_conf_data *
+vrrp_data_t *
 alloc_vrrp_data(void)
 {
-	vrrp_conf_data *new;
+	vrrp_data_t *new;
 
-	new = (vrrp_conf_data *) MALLOC(sizeof (vrrp_conf_data));
+	new = (vrrp_data_t *) MALLOC(sizeof(vrrp_data_t));
 	new->vrrp = alloc_list(free_vrrp, dump_vrrp);
 	new->vrrp_index = alloc_mlist(NULL, NULL, 255+1);
 	new->vrrp_index_fd = alloc_mlist(NULL, NULL, 1024+1);
@@ -417,7 +417,7 @@ alloc_vrrp_data(void)
 }
 
 void
-free_vrrp_data(vrrp_conf_data * data)
+free_vrrp_data(vrrp_data_t * data)
 {
 	free_list(data->static_addresses);
 	free_list(data->static_routes);
@@ -431,13 +431,13 @@ free_vrrp_data(vrrp_conf_data * data)
 }
 
 void
-free_vrrp_sockpool(vrrp_conf_data * data)
+free_vrrp_sockpool(vrrp_data_t * data)
 {
 	free_list(data->vrrp_socket_pool);
 }
 
 void
-dump_vrrp_data(vrrp_conf_data * data)
+dump_vrrp_data(vrrp_data_t * data)
 {
 	if (!LIST_ISEMPTY(data->static_addresses)) {
 		log_message(LOG_INFO, "------< Static Addresses >------");
diff -rupN keepalived-1.2.7/keepalived/vrrp/vrrp_if.c keepalived-1.2.7-unicast/keepalived/vrrp/vrrp_if.c
--- keepalived-1.2.7/keepalived/vrrp/vrrp_if.c	2012-08-17 01:21:28.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/vrrp/vrrp_if.c	2013-05-24 10:12:36.609167300 +0200
@@ -62,10 +62,10 @@ static struct ifreq ifr;
 
 /* Helper functions */
 /* Return interface from interface index */
-interface *
+interface_t *
 if_get_by_ifindex(const int ifindex)
 {
-	interface *ifp;
+	interface_t *ifp;
 	element e;
 
 	if (LIST_ISEMPTY(if_queue))
@@ -79,10 +79,10 @@ if_get_by_ifindex(const int ifindex)
 	return NULL;
 }
 
-interface *
+interface_t *
 if_get_by_ifname(const char *ifname)
 {
-	interface *ifp;
+	interface_t *ifp;
 	element e;
 
 	if (LIST_ISEMPTY(if_queue)) {
@@ -238,7 +238,7 @@ if_ethtool_probe(const char *ifname)
 }
 
 void
-if_ioctl_flags(interface * ifp)
+if_ioctl_flags(interface_t * ifp)
 {
 	int fd = socket(AF_INET, SOCK_DGRAM, 0);
 
@@ -264,7 +264,7 @@ free_if(void *data)
 void
 dump_if(void *data)
 {
-	interface *ifp = data;
+	interface_t *ifp = data;
 	char addr_str[41];
 
 	log_message(LOG_INFO, "------< NIC >------");
@@ -319,7 +319,7 @@ init_if_queue(void)
 }
 
 void
-if_add_queue(interface * ifp)
+if_add_queue(interface_t * ifp)
 {
 	list_add(if_queue, ifp);
 }
@@ -327,7 +327,7 @@ if_add_queue(interface * ifp)
 static int
 if_linkbeat_refresh_thread(thread_t * thread)
 {
-	interface *ifp = THREAD_ARG(thread);
+	interface_t *ifp = THREAD_ARG(thread);
 
 	if (IF_MII_SUPPORTED(ifp))
 		ifp->linkbeat = (if_mii_probe(ifp->ifname)) ? 1 : 0;
@@ -350,7 +350,7 @@ if_linkbeat_refresh_thread(thread_t * th
 static void
 init_if_linkbeat(void)
 {
-	interface *ifp;
+	interface_t *ifp;
 	element e;
 	int status;
 
@@ -375,7 +375,7 @@ init_if_linkbeat(void)
 }
 
 int
-if_linkbeat(const interface * ifp)
+if_linkbeat(const interface_t * ifp)
 {
 	if (!global_data->linkbeat_use_polling)
 		return 1;
@@ -416,7 +416,7 @@ init_interface_linkbeat(void)
 }
 
 int
-if_join_vrrp_group(sa_family_t family, int *sd, interface *ifp, int proto)
+if_join_vrrp_group(sa_family_t family, int *sd, interface_t *ifp, int proto)
 {
 	struct ip_mreqn imr;
 	struct ipv6_mreq imr6;
@@ -462,7 +462,7 @@ if_join_vrrp_group(sa_family_t family, i
 }
 
 int
-if_leave_vrrp_group(sa_family_t family, int sd, interface *ifp)
+if_leave_vrrp_group(sa_family_t family, int sd, interface_t *ifp)
 {
 	struct ip_mreqn imr;
 	struct ipv6_mreq imr6;
@@ -506,7 +506,7 @@ if_leave_vrrp_group(sa_family_t family,
 }
 
 int
-if_setsockopt_bindtodevice(int *sd, interface *ifp)
+if_setsockopt_bindtodevice(int *sd, interface_t *ifp)
 {
 	int ret;
 
@@ -601,7 +601,7 @@ if_setsockopt_mcast_hops(sa_family_t fam
 }
 
 int
-if_setsockopt_mcast_if(sa_family_t family, int *sd, interface *ifp)
+if_setsockopt_mcast_if(sa_family_t family, int *sd, interface_t *ifp)
 {
 	int ret;
 	unsigned int ifindex;
diff -rupN keepalived-1.2.7/keepalived/vrrp/vrrp_index.c keepalived-1.2.7-unicast/keepalived/vrrp/vrrp_index.c
--- keepalived-1.2.7/keepalived/vrrp/vrrp_index.c	2012-08-13 20:50:25.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/vrrp/vrrp_index.c	2013-05-24 10:12:36.611167400 +0200
@@ -29,15 +29,15 @@
 
 /* VRID hash table */
 void
-alloc_vrrp_bucket(vrrp_rt *vrrp)
+alloc_vrrp_bucket(vrrp_t *vrrp)
 {
 	list_add(&vrrp_data->vrrp_index[vrrp->vrid], vrrp);
 }
 
-vrrp_rt *
+vrrp_t *
 vrrp_index_lookup(const int vrid, const int fd)
 {
-	vrrp_rt *vrrp;
+	vrrp_t *vrrp;
 	element e;
 	list l = &vrrp_data->vrrp_index[vrid];
 
@@ -71,22 +71,22 @@ vrrp_index_lookup(const int vrid, const
 
 /* FD hash table */
 void
-alloc_vrrp_fd_bucket(vrrp_rt *vrrp)
+alloc_vrrp_fd_bucket(vrrp_t *vrrp)
 {
 	/* We use a mod key plus 1 */
 	list_add(&vrrp_data->vrrp_index_fd[vrrp->fd_in%1024 + 1], vrrp);
 }
 
 void
-remove_vrrp_fd_bucket(vrrp_rt *vrrp)
+remove_vrrp_fd_bucket(vrrp_t *vrrp)
 {
 	list l = &vrrp_data->vrrp_index_fd[vrrp->fd_in%1024 + 1];
 	list_del(l, vrrp);
 }
 
-void set_vrrp_fd_bucket(int old_fd, vrrp_rt *vrrp)
+void set_vrrp_fd_bucket(int old_fd, vrrp_t *vrrp)
 {
-	vrrp_rt *vrrp_ptr;
+	vrrp_t *vrrp_ptr;
 	element e;
 	list l = &vrrp_data->vrrp_index_fd[old_fd%1024 + 1];
 
diff -rupN keepalived-1.2.7/keepalived/vrrp/vrrp_ipaddress.c keepalived-1.2.7-unicast/keepalived/vrrp/vrrp_ipaddress.c
--- keepalived-1.2.7/keepalived/vrrp/vrrp_ipaddress.c	2012-08-29 00:05:12.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/vrrp/vrrp_ipaddress.c	2013-05-24 10:12:36.613167500 +0200
@@ -28,9 +28,9 @@
 #include "memory.h"
 #include "utils.h"
 
-/* Add/Delete IP address to a specific interface */
+/* Add/Delete IP address to a specific interface_t */
 static int
-netlink_ipaddress(ip_address *ipaddress, int cmd)
+netlink_ipaddress(ip_address_t *ipaddress, int cmd)
 {
 	int status = 1;
 	struct {
@@ -71,7 +71,7 @@ netlink_ipaddress(ip_address *ipaddress,
 void
 netlink_iplist(list ip_list, int cmd)
 {
-	ip_address *ipaddr;
+	ip_address_t *ipaddr;
 	element e;
 
 	/* No addresses in this list */
@@ -98,7 +98,7 @@ netlink_iplist(list ip_list, int cmd)
 void
 free_ipaddress(void *if_data)
 {
-	ip_address *ipaddr = if_data;
+	ip_address_t *ipaddr = if_data;
 
 	FREE_PTR(ipaddr->label);
 	FREE(ipaddr);
@@ -106,7 +106,7 @@ free_ipaddress(void *if_data)
 void
 dump_ipaddress(void *if_data)
 {
-	ip_address *ipaddr = if_data;
+	ip_address_t *ipaddr = if_data;
 	char *broadcast = (char *) MALLOC(21);
 	char *addr_str = (char *) MALLOC(41);
 
@@ -131,15 +131,15 @@ dump_ipaddress(void *if_data)
 	FREE(addr_str);
 }
 void
-alloc_ipaddress(list ip_list, vector_t *strvec, interface *ifp)
+alloc_ipaddress(list ip_list, vector_t *strvec, interface_t *ifp)
 {
-	ip_address *new;
-	interface *ifp_local;
+	ip_address_t *new;
+	interface_t *ifp_local;
 	char *str, *p;
 	void *addr;
 	int i = 0, addr_idx =0;
 
-	new = (ip_address *) MALLOC(sizeof(ip_address));
+	new = (ip_address_t *) MALLOC(sizeof(ip_address_t));
 	if (ifp) {
 		new->ifa.ifa_index = IF_INDEX(ifp);
 		new->ifp = ifp;
@@ -220,9 +220,9 @@ alloc_ipaddress(list ip_list, vector_t *
 
 /* Find an address in a list */
 int
-address_exist(list l, ip_address *ipaddress)
+address_exist(list l, ip_address_t *ipaddress)
 {
-	ip_address *ipaddr;
+	ip_address_t *ipaddr;
 	element e;
 
 	for (e = LIST_HEAD(l); e; ELEMENT_NEXT(e)) {
@@ -243,7 +243,7 @@ address_exist(list l, ip_address *ipaddr
 void
 clear_diff_address(list l, list n)
 {
-	ip_address *ipaddr;
+	ip_address_t *ipaddr;
 	element e;
 	char *addr_str;
 	void *addr;
